【LeetCode OJ】Max Points on a Line
Problem:
Given n points on a 2D plane, find the maximum number of points that lie on the same straight line.
Suppose that the structure Point is already defined in as following:
/**
* Definition for a point.
* struct Point {
* int x;
* int y;
* Point() : x(0), y(0) {}
* Point(int a, int b) : x(a), y(b) {}
* };
*/
Solution:
First idea coming to my mind is brute-force method which can be done in O(n^2) time...however, after I thinked hard and did some research, what I have is still O(n^2) solution. The brute-force solution is very straightforward, by given n points, there are at most n^2 different lines. To sovle the problem, we just check all possible lines and count the number of points on it. The naive approach is in O(n^3) time. However, if we check the lines of every pair of points and use a hash table to store the lines, we can do it in O(n^2) time.
Also, there is another way to solve the problem by converting the 2D-plane to its dual space. In a word, map the (points, lines)-space into a (lines, points) space. The n points are converted into n lines in the dual space, and the intersection of lines corresponds to the lines passing through those points in the original space. Therefore, instead of solving the problem "find the line pass through most points by given n points", we are asked to solve the problem "find the intersection points that most lines pass through by given n lines". The bad news is that, the time complexity to solve this new problem seems to be same as O(n^2)...
And I also tried to solve the problem from a algorithm view, use Dynamic Programming. Let M[n] be the solution to the problem with points P1, P2, ..., Pn. Then we have the recursive function as follows:
M[n] = n, if n <= 2
M[n] = max( BestSolutionPassingPoint(Pn, {P1...Pn-1}), M[n-1] ), otherwise
However, this DP is just a very simple divide-and-conquer idea. Suppose we have points P1, ..., Pn, there are only two non-overlapped cases: (1) The solution line passes through the point Pn; or (2) The solution lines does not pass through the point Pn. If case (1), then we only need to find the number of points lie on the line that also passes through Pn (the BestSolutionPassingPoint function). This can be done in O(n^2) time by using hash technique but much easier than brute-force method (I will explain it later). If case (2), removing the Pn does not change anything, which means the solution for P1,...,Pn-1 is equal to that for P1,...,Pn.
Finally, I decided to use the DP approach for two reasons:
1. The line representation and hashing lines. The key of the algorithm is to represent the line passing through two points and hash the line. Let (x1,y1) and (x2,y2) be two points, then we can represent a line by kx+y=d. However, this representation has a drawback that it is not able to cover the case of x1==x2. (Another representation is to use ax+by=c, but personally I do not like it since it requires gcd and more values to hash.) Therefore, the pair (k,d) is unique to a line, so it can be used as the hash key. However, in DP approach, all lines we concern are passing through a same point. Then we considered this point as an origin, then all lines can represented as y=kx or x=c for lines parallel to the x-axis. So we can use the value of k only as the hash key. Note that the line x=c should be considered seperately.
2. Duplicate points. We have to consider the case that there exist same points in the point set. If we use brute-force approach, we need to scan the points and count the duplicates first. For DP approach, it becomes much easier to handle the duplicates. To calculate BestSolutionPassingPoint(P, S), if there exist same point to P in S, lets say Q. What we are going to do is just to add 1 to every count since all lines must pass through Q since they passes through P.
The C++ code should like:
/**
* Definition for a point.
* struct Point {
* int x;
* int y;
* Point() : x(0), y(0) {}
* Point(int a, int b) : x(a), y(b) {}
* };
*/
#include <unordered_map> class Solution {
public:
static const int EPSILON = 1000000; // float precision purpose
std::unordered_map<int, int> lines; // We use the unordered_map, key is the slope of the line and value is the count of points
int find_sub_max_points(vector<Point> &points, int last) {
lines.clear(); // Clear the hash table
int num_same_x = 0; // count the number of points with same x-coordinate of Point[last]
int num_same_point = 1;
const int x0 = points[last].x;
const int y0 = points[last].y;
int x,y,tmp;
int res = 0;
for (int i = last-1; i >= 0; i--) {
x = points[i].x;
y = points[i].y;
if (x == x0) {
if (y == y0) num_same_point++;
else if(++num_same_x > res)
res = num_same_x;
}
else {
tmp = int( (y-y0) * EPSILON ) / (x-x0);
if (++lines[tmp] > res) res = lines[tmp];
/* the line above is equal to following lines
std::unordered_map<int,int>::const_iterator got = lines.find (tmp);
if (got == lines.end())
lines[tmp] = 1;
else
lines[tmp]++;
if (lines[tmp]>res) res = lines[tmp];
*/
}
}
return res+num_same_point; // Point[last] itself should be counted
}
int maxPoints(vector<Point> &points) {
int n = points.size();
if (n <= 2) return n;
int res = 2;
int tmp = 0;
for(int i=2; i<n; i++) {
tmp = find_sub_max_points(points, i);
if (tmp > res) res = tmp;
}
return res;
}
};
C++ basics:
In C++, we can use <unordered_map> as hash table. And there is a very quick way to do the following update:
if the key is not in contained in the hash table, then set the key with value 1;
otherwise, add 1 to the key's value.
This udpate can be done in one line (see code) since the HashTable[key] is set to 0 if the key does not exist.
【LeetCode OJ】Max Points on a Line的更多相关文章
- 【leetcode】Max Points on a Line
Max Points on a Line 题目描述: Given n points on a 2D plane, find the maximum number of points that lie ...
- 【LeetCode OJ】Interleaving String
Problem Link: http://oj.leetcode.com/problems/interleaving-string/ Given s1, s2, s3, find whether s3 ...
- 【LeetCode OJ】Reverse Words in a String
Problem link: http://oj.leetcode.com/problems/reverse-words-in-a-string/ Given an input string, reve ...
- 【leetcode】Max Points on a Line(hard)☆
Given n points on a 2D plane, find the maximum number of points that lie on the same straight line. ...
- 【leetcode刷题笔记】Max Points on a Line
Given n points on a 2D plane, find the maximum number of points that lie on the same straight line. ...
- 【LeetCode OJ】Balanced Binary Tree
Problem Link: http://oj.leetcode.com/problems/balanced-binary-tree/ We use a recursive auxilar funct ...
- 【LeetCode OJ】Best Time to Buy and Sell Stock III
Problem Link: http://oj.leetcode.com/problems/best-time-to-buy-and-sell-stock-iii/ Linear Time Solut ...
- 【LeetCode OJ】Binary Tree Maximum Path Sum
Problem Link: http://oj.leetcode.com/problems/binary-tree-maximum-path-sum/ For any path P in a bina ...
- 【LeetCode OJ】Longest Consecutive Sequence
Problem Link: http://oj.leetcode.com/problems/longest-consecutive-sequence/ This problem is a classi ...
随机推荐
- hdu----(3118)Arbiter(构造二分图)
Arbiter Time Limit: 1000/1000 MS (Java/Others) Memory Limit: 131072/131072 K (Java/Others)Total S ...
- 平衡查找树之B树
转自:http://www.cnblogs.com/yangecnu/p/Introduce-B-Tree-and-B-Plus-Tree.html 定义 B 树可以看作是对2-3查找树的一种扩展,即 ...
- CPU厂商
1·Intel公司 Intel是生产CPU的老大哥,它占有大约80%的市场份额,Intel生产的CPU就成了事实上的x86CPU技术规范和标准.最新的酷睿2成为CPU的首选. 2·AMD公司 除了In ...
- VBA读取可选择文件夹下可选择txt文件内容
Sub OneTxt() '打开一个txt文件 Dim Filename As Variant, extLine&, mArr() As String Dim i%, j% ChDir Thi ...
- Mysqldump参数大全
Mysqldump参数大全(参数来源于mysql5.5.19源码) 参数 参数说明 --all-databases , -A 导出全部数据库. mysqldump -uroot -p --al ...
- fwite写入文件
用双引号(")定义字符串,PHP 懂得更多特殊字符的转义序列: 转移序列 说明 \n 换行 \r 回车 \t 水平制表符 \[/td> 反斜线 \$ 美元符号 \" 双引号 ...
- HTTPS是如何保证连接安全,你知道吗?
HTTPS协议的工作原理是什么?”这是我在数天前工作项目中需要解决的问题. 作为一名Web开发者,我当然知道 HTTPS 协议是保障用户敏感数据的好办法,但并不知道这种协议的内在工作机制. 它怎么保护 ...
- UVa 10561 - Treblecross
http://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&page=show_problem&p ...
- POJ 2886 Who Gets the Most Candies?
思路: 对于 k 位置的 孩子,他的 数字是 +num 那么因为他自己本身是要被踢走的,所以相对位置 为k= k+num-1 如果数字是 -num,那么按正着数就没影响,k=k-num.线段树存储当前 ...
- PowerMock使用遇到的问题——1
遇到问题:再用PowerMock Mock构造方法时,所有语句都可以通过执行,但当最后执行verify语句时却总是出现如下错误: java.lang.AssertionError: ...